#include "gridftpFileDriver.h"
#include "gridftp.h"
#include <stdio.h>
#include <stdlib.h>

int gridFtpFileUnlink(rsComm_t *rsComm, char *filename) {
	printInfo("gridFtpFileUnlink: %s", filename);
	setUserProxy(rsComm);
	int status = gridftp_del(filename);
	return status;
}

int gridFtpFileStat(rsComm_t *rsComm, char *filename, struct stat *statbuf) {
	//	TODO
	printInfo("gridFtpFileStat: %s", filename);
	int status = 0;
	return status;
}

int gridFtpFileFsync(rsComm_t *rsComm, int fd) {
	//	TODO
	printInfo("gridFtpFileFsync: %i", fd);
	int status = 0;
	return status;
}

int gridFtpFileMkdir(rsComm_t *rsComm, char *filename, int mode) {
	printInfo("gridFtpFileMkdir: %s %i", filename, mode);
	setUserProxy(rsComm);
	int status = gridftp_mkdir(filename);
	return status;
}

int gridFtpFileChmod(rsComm_t *rsComm, char *filename, int mode) {
	printInfo("gridFtpFileChmod: %s %i", filename, mode);
	setUserProxy(rsComm);
	char mode_c = malloc(8 * sizeof(char));
	sprintf(mode_c, "%i", mode);
	int status = gridftp_chmod(filename,mode_c);
	return status;
}

int gridFtpFileRmdir(rsComm_t *rsComm, char *filename) {
	printInfo("gridFtpFileRmdir: %s", filename);
	setUserProxy(rsComm);
	int status = gridftp_rmdir(filename);
	return status;
}

int gridFtpFileReaddir(rsComm_t *rsComm, void *dirPtr, struct dirent *direntPtr) {
	//	TODO
	printInfo("gridFtpFileReaddir:");
	int status = 0;
	return status;
}

int gridFtpFileStage(rsComm_t *rsComm, char *path, int flag) {
	//	TODO
	printInfo("gridFtpFileStage: %s %i", path, flag);
	int status = 0;
	return status;
}

int gridFtpFileRename(rsComm_t *rsComm, char *oldFileName, char *newFileName) {
	printInfo("gridFtpFileRename: %s %s", oldFileName, newFileName);
	setUserProxy(rsComm);
	int status = gridftp_mv(oldFileName, newFileName);
	return status;
}

int gridFtpFileCopy(int mode, char *srcFileName, char *destFileName) {
	//	TODO
	printInfo("gridFtpFileCopy: %s %s", srcFileName, destFileName);
	int status = gridftp_cp(srcFileName, destFileName);
	return status;
}


/*
 *	Removes the iRODS user home directory from the GridFTP URL.
 *
 *	@param url		GridFTP URL to change
 *	@param rsComm	iRODS server communication handle containing
 *		 			user information
 */
void changeFilename(char *url, rsComm_t *rsComm) {

#ifdef GRIDFTP_DRIVER_CHANGE_URL
	printInfo("filename: %s", url);
	char *zonePref = rsComm->myEnv.rodsHome + (strlen(rsComm->myEnv.rodsZone)) + 1;
	char *suffix = strstr(url, zonePref) + strlen(zonePref);
	char *tmp = strstr(url, zonePref);
	strcpy(tmp, "");
	strcat(url, suffix);
	printInfo("changed to: %s", url);
#endif
}

int gridFtpStageToCache(
        rsComm_t *rsComm,
        fileDriverType_t cacheFileType,
        int mode,
        int flags,
        char *filename,
        char *cacheFilename,
        rodsLong_t dataSize,
        keyValPair_t *condInput) {

	changeFilename(filename, rsComm);
	printInfo("gridFtpStageToCache: %s %s", filename, cacheFilename);
	setUserProxy(rsComm);
	int status = gridftp_get(filename, cacheFilename);
	return status;
}

int gridFtpSyncToArch(
        rsComm_t *rsComm,
        fileDriverType_t cacheFileType,
        int mode,
        int flags,
        char *filename,
        char *cacheFilename,
        rodsLong_t dataSize,
        keyValPair_t *condInput) {

	changeFilename(filename, rsComm);
	printInfo("gridFtpSyncToArch: %s %s", cacheFilename, filename);
	setUserProxy(rsComm);
	int status = gridftp_put(cacheFilename, filename);

	return status;
}

/*
int gridFtpFileCreate(rsComm_t *rsComm, char *fileName, int mode) {
	printInfo("gridFtpFileCreate: %s %i", fileName, mode);
	int fd = 0;
	return fd;
}
/*
int gridFtpFileOpen(rsComm_t *rsComm, char *fileName, int flags, int mode) {
	int fd;
	return fd;
}

int gridFtpFileRead(rsComm_t *rsComm, int fd, void *buf, int len) {
	int status;
	return status;
}
* /
int gridFtpFileWrite(rsComm_t *rsComm, int fd, void *buf, int len) {
	printInfo("gridFtpFileWrite: %i %i %s", fd, len, (char *) buf);
	int status = 0;
//	return status;
	return len;
}

int gridFtpFileClose(rsComm_t *rsComm, int fd) {
	printInfo("gridFtpFileClose: %i", fd);
	int status = 0;
	return status;
}
/*
int gridFtpFileFstat(rsComm_t *rsComm, int fd, struct stat *statbuf) {
	int status;
	return status;
}

rodsLong_t gridFtpFileLseek(rsComm_t *rsComm, int fd, rodsLong_t offset, int whence) {
	rodsLong_t status;
	return status;
}

int gridFtpFileOpendir(rsComm_t *rsComm, char *dirname, void **outDirPtr) {
	int status;
	return status;
}

int gridFtpFileClosedir(rsComm_t *rsComm, void *dirPtr) {
	int status;
	return status;
}

int gridFtpFileTruncate(rsComm_t *rsComm, char *filename, rodsLong_t dataSize) {
	int status;
	return status;
}

rodsLong_t gridFtpFileGetFsFreeSpace(rsComm_t *rsComm, char *path, int flag) {
	int status;
	rodsLong_t fssize = USER_NO_SUPPORT_ERR;
	return fssize;
}
*/
